package Modelo;

import java.util.ArrayList; 
import java.util.Observable;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.9A3170D6-46A9-826A-FD41-62CCF154D9E0]
// </editor-fold> 
public class DocumentoReq extends Observable{

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.AD2CFA70-6D3B-6112-498A-DFC58CBBEA9E]
    // </editor-fold> 
    private ArrayList<Elemento_trazable> mCaso_de_uso=new ArrayList();

    private ArrayList<Elemento_trazable> mRequisito_funcional=new ArrayList();

    private ArrayList<Elemento_trazable> mRequisito_Informacion=new ArrayList();

    private ArrayList<Elemento_trazable> mRequisito_noFuncional=new ArrayList();
    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,id=DCE.9E78B0E9-53A7-5C64-1340-81339CAE97DD]
    // </editor-fold> 
    public DocumentoReq () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.146E6F51-B37B-C9F7-80C6-5D93847A1307]
    // </editor-fold> 
    public Caso_de_uso crearCU (String nombreCU, String comentario,String participante,String fuente,String importancia,String urgencia, String estadodeDesarrollo,String estabilidad,boolean esAbstracto,String eventoActivacion, int frecuencia, String unidadFrecuencia, String precondicion, String postcondicion) {
                //// Creo la instancia
        Caso_de_uso auxCU=new Caso_de_uso();
        //// Asigno los valores a los atributos
        auxCU.setNombre(nombreCU);
        auxCU.setComentario(comentario);
        auxCU.setParticipante(participante);
        auxCU.setFuente(fuente);
        auxCU.setImportancia(importancia);
        auxCU.setUrgencia(urgencia);
        auxCU.setEstadodeDesarrollo(estadodeDesarrollo);
        auxCU.setEstabilidad(estabilidad);
        auxCU.setEsAbstracto(esAbstracto);
        auxCU.setEventoActivacion(eventoActivacion);
        auxCU.setFrecuencia(frecuencia);
        auxCU.setUnidadFrecuencia(unidadFrecuencia);
        auxCU.setPrecondicion(precondicion);
        auxCU.setPostcondicion(postcondicion);

        //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        this.getCaso_de_uso().add(auxCU);
        setChanged();
        notifyObservers();
        return auxCU;
    }

    public Elemento_trazable buscarporNombreCU (String nombre){
        int i=0;
        boolean enc=false;
        while(!enc && i<this.getCaso_de_uso().size()){
            if(this.getCaso_de_uso().get(i).getNombre().equals(nombre)){
                enc=true;
            }
            else{i++;}
        }
        if(enc) return this.getCaso_de_uso().get(i);
        else return null;
       
    }
    public Elemento_trazable buscarporNombreRI (String nombre){
        int i=0;
        boolean enc=false;
        while(!enc && i<this.getMRequisito_Informacion().size()){
            if(this.getMRequisito_Informacion().get(i).getNombre().equals(nombre)){
                enc=true;
            }
            else{i++;}
        }
        if(enc) return this.getMRequisito_Informacion().get(i);
        else return null;

    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.80173724-3F8F-EF4A-D99E-15817CA65636]
    // </editor-fold> 
    public ArrayList<Elemento_trazable> getCaso_de_uso () {
        return mCaso_de_uso;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.DD623546-2AFE-4D5B-5D3A-03A0B28B6761]
    // </editor-fold> 
    public void setCaso_de_uso (ArrayList<Elemento_trazable> val) {
        this.mCaso_de_uso = val;
    }

    /**
     * @return the mRequisito_funcional
     */
    public ArrayList<Elemento_trazable> getMRequisito_funcional() {
        return mRequisito_funcional;
    }

    /**
     * @param mRequisito_funcional the mRequisito_funcional to set
     */
    public void setMRequisito_funcional(ArrayList<Elemento_trazable> mRequisito_funcional) {
        this.mRequisito_funcional = mRequisito_funcional;
    }

    public Req_funcional crearReqFuncional(String nombre, String comentario,String participante, String fuente, String descripcion, String importancia, String urgencia, String est_desarrollo, String estabilidad){
        Req_funcional rF= new Req_funcional();

        rF.setNombre(nombre);
        rF.setComentario(comentario);
        rF.setParticipante(participante);
        rF.setFuente(fuente);
        rF.setDescripcion(descripcion);
        rF.setImportancia(importancia);
        rF.setUrgencia(urgencia);
        rF.setEstadodeDesarrollo(est_desarrollo);
        rF.setEstabilidad(estabilidad);

        this.getMRequisito_funcional().add(rF);
        setChanged();
        notifyObservers();

        return rF;
    }

    /**
     * @return the mRequisito_Informacion
     */
    public ArrayList<Elemento_trazable> getMRequisito_Informacion() {
        return mRequisito_Informacion;
    }

    /**
     * @param mRequisito_Informacion the mRequisito_Informacion to set
     */
    public void setMRequisito_Informacion(ArrayList<Elemento_trazable> mRequisito_Informacion) {
        this.mRequisito_Informacion = mRequisito_Informacion;
    }

    public Req_informacion crearReqInformacion(String nombre, String comentario,String participante, String fuente, String descripcion, int tMaxValor, String tMaxUnidad, int tMedValor, String tMedUnidad, int nMax, int nMed, String importancia, String urgencia, String est_desarrollo, String estabilidad){
        Req_informacion rI= new Req_informacion();

        rI.setNombre(nombre);
        rI.setComentario(comentario);
        rI.setParticipante(participante);
        rI.setFuente(fuente);
        rI.setTiempMaxVida_Valor(tMaxValor);
        rI.setTiempoMaxVida_Unidad(tMaxUnidad);
        rI.setTiempoMedVida_Valor(tMedValor);
        rI.setTiempoMedVida_Unidad(tMedUnidad);
        rI.setNMax(nMax);
        rI.setNMed(nMed);
        rI.setDescripcion(descripcion);
        rI.setImportancia(importancia);
        rI.setUrgencia(urgencia);
        rI.setEstadodeDesarrollo(est_desarrollo);
        rI.setEstabilidad(estabilidad);

        this.mRequisito_Informacion.add(rI);
        setChanged();
        notifyObservers();
        return rI;
    }

    /**
     * @return the mRequisito_noFuncioanl
     */
    public ArrayList<Elemento_trazable> getMRequisito_noFuncional() {
        return mRequisito_noFuncional;
    }

    /**
     * @param mRequisito_noFuncioanl the mRequisito_noFuncional to set
     */
    public void setMRequisito_noFuncional(ArrayList<Elemento_trazable> mRequisito_noFuncional) {
        this.mRequisito_noFuncional = mRequisito_noFuncional;
    }

    public Requisito_no_funcional crearRequisito_noFuncional(String nombre, String comentario,String participante, String fuente, String descripcion,String importancia, String urgencia, String est_desarrollo, String estabilidad){
        Requisito_no_funcional rnF= new Requisito_no_funcional();

        rnF.setNombre(nombre);
        rnF.setComentario(comentario);
        rnF.setParticipante(participante);
        rnF.setFuente(fuente);
        rnF.setDescripcion(descripcion);
        rnF.setImportancia(importancia);
        rnF.setUrgencia(urgencia);
        rnF.setEstadodeDesarrollo(est_desarrollo);
        rnF.setEstabilidad(estabilidad);

        this.getMRequisito_funcional().add(rnF);
        setChanged();
        notifyObservers();
        
        return rnF;
    }

}

